# TransformMix
TransformMix: Learning Transformation and Mixing Strategy for Sample-mixing Data Augmentation

### Table of Contents

1. [Introduction](#introduction)
2. [Getting Started](#getting-started)
3. [Run Search](#run-transformmix-search)

### Introduction

TransformMix is an automated method to learn a mixing module for predicting the transformations and mixing masks to create more advantageous mixed images that preserves saliency information in the input images.
This repository contains code for the work "TransformMix: Learning Transformation and Mixing Strategy for Sample-mixing Data Augmentation" implemented in PyTorch.

### Getting Started
Code supports Python 3.

####  Install requirements

```shell
pip install -r requirements.txt
```

####  Setting up directory path
In `scripts/train_augmentor.sh`, specify the dataset path for `ROOT` and the path to the pre-trained teacher model `MMP`.

### Run TransformMix search
Script to TransformMix is located in `scripts/train_augmentor.sh`. Pass the dataset name as the arguement to call the script.

For example, to train TransformMix on CIFAR-100:

```shell
bash scripts/train_augmentor.sh cifar100 train
```

The training log and learned mixing module will be output to the `./augmentor` directory.
